﻿
using System.Numerics;

var c1 = new Complex<float>(1, 0);
Console.WriteLine(c1);

var c2 = new Complex<float>(4, 3);
Console.WriteLine(c2);

var c3 = c1 + c2;
Console.WriteLine(c3);

c3 = c3 * 10;
Console.WriteLine(c3);

public readonly record struct Complex<T>(
		T Real, T Imaginary
	) where T : IFloatingPoint<T> {

	public static Complex<T> operator+(Complex<T> left, Complex<T> right)
		=> new Complex<T>(left.Real + right.Real, left.Imaginary + right.Imaginary);

	public static Complex<T> operator*(Complex<T> left, T right) 
		=> new Complex<T>(left.Real * right, left.Imaginary * right);
}
